{    var   : }
{ N, F, FE }
Unit MN11R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MN214_p, MNP13_p, MNP16_p;

procedure MN11R(var N :Integer; var X :Array of Real;
                var XE :Array of Real; var A :Array of Real;
                var B :Array of Real; var G :Array of Real;
                var H :Array of Real; FSTEP :Real; IPAR :Integer;
                var MAXK :Integer; var F :Real; var FE :Real;
                var KOUNT :Integer; var I0 :Array of Integer;
                var RM :Array of Real; var IERR :Integer);

implementation

procedure MN11R(var N :Integer; var X :Array of Real;
                var XE :Array of Real; var A :Array of Real;
                var B :Array of Real; var G :Array of Real;
                var H :Array of Real; FSTEP :Real; IPAR :Integer;
                var MAXK :Integer; var F :Real; var FE :Real;
                var KOUNT :Integer; var I0 :Array of Integer;
                var RM :Array of Real; var IERR :Integer);
var
I,IRM,IUP,N3 :Integer;
//W :Real;
W :Integer;
label
_10,_20,_30,_40;
begin
W := 0;
IRM := 1;
IUP := IRM + 3*N + 8;
I := IUP + N + 1;
RM[I-1] := FSTEP;
RM[I+0] := IPAR;
RM[1] := MAXK;
for I:=1 to N do
 begin
  I0[I-1] := 1;
_10:
 end;
RM[1] := RM[1]*(-1.0);
MNP13(N,X,XE,F,FE,G,H,RM[IRM-1],RM[IUP-1]);
_20:
for I:=1 to N do
 begin
  if ( I0[I-1] =  0 )
   then goto _30;
  MN214(I,N,X,XE,F,FE,A,B,G,H,I0,RM[IRM-1],RM[IUP-1]);
  if ( RM[1] >=  0 )
   then W := 4;
  if ( W =  4 )
   then goto _40;
_30:
 end;
MNP16(N,XE,FE,RM[IRM-1],RM[IUP-1],I0,W);
if ( W =  0 )
 then goto _20;
N3 := 4 + 3*N;
if ( RM[N3+0] <>  N )
 then goto _20;
W := 0;
_40:
IERR := Trunc( W );
RM[1] := MAXK + RM[1];
KOUNT := Trunc( RM[0] );
MAXK := Trunc( RM[1] );
end;

end.
