{    var   : }
{ N, F, FE }
Unit MN214_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MN215_p, MNP11_p;

procedure MN214(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var A :Array of Real; var B :Array of Real;
                var G :Array of Real; var H :Array of Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real);

implementation

procedure MN214(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; var FE :Real;
                var A :Array of Real; var B :Array of Real;
                var G :Array of Real; var H :Array of Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real);
var
L,N1,N2,N3 :Integer;
FT2,RE1,XF :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80;
begin
N1 := I + N + 4;
N2 := I + 2*N + 4;
N3 := 3*N + 7;
XF := X[I-1];
RM[N3-1] := RM[N2-1];
if ( UP[N+2] =  0 ) 
 then RM[N3-1] := UP[N+1];
RE1 := -RM[N3-1]*RM[N3-1];
L := 0;
X[I-1] := XF + Sign(RM[N3-1],RM[N1-1]);
_10:
if ( X[I-1] <  A[I-1] ) 
 then goto _20;
if ( X[I-1] >  B[I-1] ) 
 then goto _20;
MNP11(N,H,X,G,FT2);
RM[N3+0] := FT2;
RM[1] := RM[1] + 1.0;
if ( RM[1] >=  0 ) 
 then goto _80;
if ( Abs(FT2-F) <=  FE ) 
 then goto _60;
if ( FT2 - F <=  RE1 ) 
 then goto _30;
_20:
if ( L =  1 ) 
 then goto _40;
L := 1;
X[I-1] := XF - Sign(RM[N3-1],RM[N1-1]);
goto _10;
_30:
MN215(I,N,X,XE,F,FE,A,B,G,H,I0,RM,UP,XF);
goto _70;
_40:
RM[N3-1] := RM[N3-1]/2.0;
X[I-1] := XF;
if ( UP[N+2] =  1 ) 
 then goto _50;
RM[N3-2] := RM[N3-2] + 1.0;
if ( RM[N3-2] <  N - RM[N3-3] ) 
 then goto _70;
UP[N+1] := RM[N3-1];
RM[N3-2] := 0.0;
RM[N2-1] := RM[N2-1]/2.0;
if ( RM[N3-1] >  XE[I-1] ) 
 then goto _70;
RM[N3-3] := N;
RM[0] := RM[0] + 1;
goto _80;
_50:
RM[N2-1] := RM[N3-1];
if ( RM[N3-1] <=  XE[I-1] ) 
 then goto _60;
goto _70;
_60:
X[I-1] := XF;
I0[I-1] := 0;
RM[N3-3] := RM[N3-3] + 1;
if ( UP[N+2] =  1 ) 
 then RM[N2-1] := RM[N3-1];
_70:
RM[0] := RM[0] + 1;
_80:
end;

end.
