{    var   : }
{ N }
Unit MN215_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MNP11_p;

procedure MN215(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; FE :Real;
                var A :Array of Real; var B :Array of Real;
                var G :Array of Real; var H :Array of Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real; XF :Real);

implementation

procedure MN215(I :Integer; var N :Integer; var X :Array of Real;
                var XE :Array of Real; var F :Real; FE :Real;
                var A :Array of Real; var B :Array of Real;
                var G :Array of Real; var H :Array of Real;
                var I0 :Array of Integer; var RM :Array of Real;
                var UP :Array of Real; XF :Real);
var
N1,N3 :Integer;
label
_10,_20,_30,_40;
begin
N1 := I + N + 4;
N3 := 4 + 3*N;
if ( X[I-1] >  A[I-1] + 2.0*XE[I-1] ) 
 then goto _10;
X[I-1] := A[I-1];
RM[N1-1] := 1.0;
goto _20;
_10:
if ( X[I-1] <  B[I-1] - 2.0*XE[I-1] ) 
 then goto _30;
X[I-1] := B[I-1];
RM[N1-1] := -1.0;
_20:
MNP11(N,H,X,G,F);
I0[I-1] := 0;
RM[N3+0] := RM[N3+0] + 1;
RM[1] := RM[1] + 1;
goto _40;
_30:
RM[N1-1] := Sign(1.0,X[I-1] - XF);
F := RM[N3+3];
_40:
RM[N3+1] := 0;
end;

end.
