Unit MNP11_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNP11(M :Integer; var H :Array of Real;
                var U :Array of Real; var G :Array of Real;
                var FIU :Real);

implementation

procedure MNP11(M :Integer; var H :Array of Real;
                var U :Array of Real; var G :Array of Real;
                var FIU :Real);
var
I,J,K :Integer;
S :Real;
label
_10,_20,_30,_40;
begin
FIU := 0.0;
for I:=1 to M do
 begin
  S := 0.0;
  for J:=1 to M do
   begin
    if ( I - J ) < 0
     then goto _10
     else if ( I - J ) > 0
           then goto _20
           else goto _20;
_10:
    K := I + J*(J - 1) div 2;
    goto _30;
_20:
    K := J + I*(I - 1) div 2;
_30:
    S := S + G[K-1]*U[J-1];
   end;
  FIU := FIU + S*U[I-1] + H[I-1]*U[I-1];
_40:
 end;
end;

end.
