Unit MNP16_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNP16(N :Integer; var XE :Array of Real; var FE :Real;
                var RM :Array of Real; var UP :Array of Real;
                var I0 :Array of Integer; var W :Integer);

implementation

procedure MNP16(N :Integer; var XE :Array of Real; var FE :Real;
                var RM :Array of Real; var UP :Array of Real;
                var I0 :Array of Integer; var W :Integer);
var
I,N3 :Integer;
label
_10,_20;
begin
N3 := 4 + 3*N;
W := 2;
if ( FE <=  1.01*RM[3] ) 
 then goto _20;
W := 0;
if ( 2*RM[N3+0] <=  N ) 
 then goto _20;
FE := FE/UP[0];
for I:=1 to N do
 begin
  XE[I-1] := XE[I-1]/UP[I+0];
  I0[I-1] := 1;
_10:
 end;
RM[N3+0] := 0;
_20:
end;

end.
